/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.standalone;

import org.jboss.aop.AspectManager;

import java.lang.instrument.ClassFileTransformer;
import java.lang.instrument.IllegalClassFormatException;
import java.lang.instrument.Instrumentation;
import java.security.ProtectionDomain;
/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1 $
 */
public class Agent
{
   private static class Transformer implements ClassFileTransformer
   {
      public byte[] transform(ClassLoader loader, String className, Class<?> classBeingRedefined, ProtectionDomain protectionDomain, byte[] classfileBuffer) throws IllegalClassFormatException
      {
         try
         {
            className = className.replace('/', '.');
            return AspectManager.instance().transform(loader, className, classBeingRedefined, protectionDomain, classfileBuffer);
         }
         catch (Exception e)
         {
            throw new RuntimeException(e);
         }
      }
   }

   public static void premain(String agentArgs, Instrumentation inst)
   {
      AspectManager.classPoolFactory = new StandaloneClassPoolFactory();
      inst.addTransformer(new Transformer());
   }
}
