/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.standalone;

import javassist.CannotCompileException;
import javassist.ClassPool;
import javassist.CtClass;
import javassist.NotFoundException;
import org.jboss.aop.AOPClassPool;
import org.jboss.aop.AspectManager;

import java.io.IOException;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.3 $
 * @deprecated Will be removed when Javassist is upgraded past 3.0 beta2
 */
public class StandaloneClassPool extends AOPClassPool
{
   public StandaloneClassPool(ClassLoader cl, ClassPool src, AspectManager manager)
   {
      super(cl, src, manager);
   }

   public StandaloneClassPool(ClassPool src, AspectManager manager)
   {
      super(src, manager);
   }

   //KAB: removed NotFoundException, IOException from throws clause, as 
   //they are not defined by javassist.ClassPool
   public Class toClass(CtClass ctClass) throws CannotCompileException/*, NotFoundException, IOException*/
   {
      try
      {
         byte[] b = ctClass.toBytecode();
         Class cl = Class.forName("java.lang.ClassLoader");
         java.lang.reflect.Method method
                 = cl.getDeclaredMethod("defineClass",
                         new Class[]{String.class, byte[].class,
                                     int.class, int.class});
         method.setAccessible(true);
         Object[] args = new Object[]{ctClass.getName(), b, new Integer(0),
                                      new Integer(b.length)};
         Class clazz = (Class) method.invoke(dcl, args);
         method.setAccessible(false);
         return clazz;
      }
      catch (RuntimeException e)
      {
         throw e;
      }
      catch (java.lang.reflect.InvocationTargetException e)
      {
         throw new CannotCompileException(e.getCause().getMessage());
      }
      catch (Exception e)
      {
         throw new CannotCompileException(e);
      }
   }

   public synchronized CtClass getLocally(String classname) throws NotFoundException
   {
      return super.getLocally(classname);
   }
}
