/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop;

import org.jboss.aop.advice.Interceptor;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.3 $
 *
 **/
public class CallerConstructorInfo
{
   public CallerConstructorInfo(Constructor called, Method wrapping, Interceptor[] in)
   {
      this.interceptors = in;
      this.wrappingMethod = wrapping;
      this.constructor = called;
   }

   public CallerConstructorInfo(Constructor c, Interceptor[] in)
   {
      this.interceptors = in;
      this.wrappingMethod = null;
      this.constructor = c;
   }

   public Interceptor[] interceptors;
   public final Method wrappingMethod;
   public final Constructor constructor;
}
