/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.advice;

import org.jboss.aop.Advisor;
import org.jboss.aop.InstanceAdvisor;
import org.jboss.aop.joinpoint.Joinpoint;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 */
public interface AspectFactory
{
   Object createPerVM();
   Object createPerClass(Advisor advisor);
   Object createPerInstance(Advisor advisor, InstanceAdvisor instanceAdvisor);
   Object createPerJoinpoint(Advisor advisor, Joinpoint jp);
   Object createPerJoinpoint(Advisor advisor, InstanceAdvisor instanceAdvisor, Joinpoint jp);

   String getName();
}
