/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.advice;

import org.jboss.aop.Advisor;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.4 $
 *
 **/
public class PerClassAdvice
{
   public static Interceptor generate(Advisor advisor, String adviceName, AspectDefinition def) throws Exception
   {
      if (advisor.getAdviceInterceptor(def, adviceName) != null) return advisor.getAdviceInterceptor(def, adviceName);
      advisor.addPerClassAspect(def);
      Object aspect = advisor.getPerClassAspect(def);
      Interceptor interceptor = PerVmAdvice.generateInterceptor(aspect, adviceName);
      advisor.addAdviceInterceptor(def, adviceName, interceptor);
      return interceptor;
   }


}
