/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.advice;

import java.io.ObjectStreamException;

/**
 * Defines the lifecycle of an aspect or interceptor instance
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.6 $
 */
public class Scope extends org.jboss.lang.Enum
{
   private Scope(String name, int v)
   {
      super(name, v);
   }

   public static final Scope PER_VM = new Scope("PER_VM", 0);
   public static final Scope PER_CLASS = new Scope("PER_CLASS", 1);
   public static final Scope PER_INSTANCE = new Scope("PER_INSTANCE", 2);
   public static final Scope PER_JOINPOINT = new Scope("PER_JOINPOINT", 3);
   private static final Scope[] values = {PER_VM, PER_CLASS, PER_INSTANCE, PER_JOINPOINT};

   Object readResolve() throws ObjectStreamException
   {
      return values[ordinal];
   }

}
