package org.jboss.aop.annotation.ast;



public class AnnotationParserTester implements AnnotationParserVisitor
{
   private int indent = 0;

   private String indentString()
   {
      StringBuffer sb = new StringBuffer();
      for (int i = 0; i < indent; ++i)
      {
         sb.append(" ");
      }
      return sb.toString();
   }

   public Object visit(ASTSingleMemberValue node, Object data)
   {
      System.out.println(indentString() + node);
      ++indent;
      data = node.childrenAccept(this, data);
      --indent;
      return data;
   }

   public Object visit(SimpleNode node, Object data)
   {
      System.out.println(indentString() + node +
              ": acceptor not unimplemented in subclass?");
      ++indent;
      data = node.childrenAccept(this, data);
      --indent;
      return data;
   }

   public Object visit(ASTStart node, Object data)
   {
      System.out.println(indentString() + node);
      ++indent;
      data = node.childrenAccept(this, data);
      --indent;
      return data;
   }

   public Object visit(ASTAnnotation node, Object data)
   {
      System.out.println(indentString() + node);
      ++indent;
      data = node.childrenAccept(this, data);
      --indent;
      return data;
   }

   public Object visit(ASTMemberValuePairs node, Object data)
   {
      System.out.println(indentString() + node);
      ++indent;
      data = node.childrenAccept(this, data);
      --indent;
      return data;
   }

   public Object visit(ASTMemberValuePair node, Object data)
   {
      System.out.println(indentString() + node);
      ++indent;
      data = node.childrenAccept(this, data);
      --indent;
      return data;
   }

   public Object visit(ASTMemberValueArrayInitializer node, Object data)
   {
      System.out.println(indentString() + node);
      ++indent;
      data = node.childrenAccept(this, data);
      --indent;
      return data;
   }

   public Object visit(ASTIdentifier node, Object data)
   {
      System.out.println(indentString() + node);
      ++indent;
      data = node.childrenAccept(this, data);
      --indent;
      return data;
   }

   public Object visit(ASTString node, Object data)
   {
      System.out.println(indentString() + node);
      ++indent;
      data = node.childrenAccept(this, data);
      --indent;
      return data;
   }

   public Object visit(ASTChar node, Object data)
   {
      System.out.println(indentString() + node);
      ++indent;
      data = node.childrenAccept(this, data);
      --indent;
      return data;
   }

   public static void main(String args[])
   {
//      System.out.println("----" + args[0]);
//      StringReader reader = new StringReader(args[0]);
      System.out.println("Reading from stdin");
      AnnotationParser t = new AnnotationParser(System.in);
      //PointcutExpressionParser t = new PointcutExpressionParser(System.in);
      try
      {
         ASTStart n = t.Start();
         AnnotationParserVisitor v = new AnnotationParserTester();
         n.jjtAccept(v, null);
      }
      catch (Exception e)
      {
         System.out.println("Oops.");
         System.out.println(e.getMessage());
         e.printStackTrace();
      }
   }
}

/*end*/
