/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.annotation.compiler;



/**
 * Convert doclet tags to JBoss AOP annotation XML
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 *
 **/
public class AnnotationCompiler
{
   public static void main(String[] args) throws Exception
   {
      AnnotationCompiler c = new AnnotationCompiler();
      c.compile(args);
   }

   public void usage()
   {
      System.err.println("Usage: annotationc [-bytecode] [-xml -o <output xml file> ] <files>+");
   }

   public void compile(String[] args) throws Exception
   {
      if (args.length == 0)
      {
         usage();
         System.exit(1);
         return;
      }
      for (int i = 0; i < args.length; i++)
      {
         if (args[i].equals("-bytecode"))
         {
            ByteCodeAnnotationCompiler compiler = new ByteCodeAnnotationCompiler();
            try
            {
               compiler.compile(args);
            }
            catch (Exception e)
            {
               e.printStackTrace(System.out);
               throw e;
            }
            return;
         }
         if (args[i].equals("-xml"))
         {
            XmlAnnotationCompiler compiler = new XmlAnnotationCompiler();
            compiler.compile(args);
            return;
         }
      }
      usage();
      System.exit(1);
      return;
   }
}
