/***************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ***************************************/

package org.jboss.aop.hook ;

import org.jboss.aop.AspectManager;

/**
 * Provide an instrumented version of java.lang.ClassLoader.
 * @author kevin
 */
public class ClassLoaderInstrumenter
{
    /**
     * Return the instrumented class loader.
     * @return The bytes for the instrumented class loader.
     * @throws Exception any exception from the aspect manager.
     */
    public static byte[] getClassLoader()
        throws Exception
    {
        return AspectManager.instance().getInstrumentedClassLoader() ;
    }
}
