/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.joinpoint;

import java.lang.reflect.Constructor;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 */
public class ConstructorCalledByConstructorJoinpoint implements Joinpoint
{
   private final Constructor calling;
   private final Constructor called;

   public ConstructorCalledByConstructorJoinpoint(Constructor calling, Constructor called)
   {
      this.calling = calling;
      this.called = called;
   }

   public boolean equals(Object o)
   {
      if (o == null) return false;
      if (o == this) return true;
      if (!(o instanceof ConstructorCalledByConstructorJoinpoint)) return false;
      ConstructorCalledByConstructorJoinpoint jp = (ConstructorCalledByConstructorJoinpoint)o;
      if (!jp.calling.equals(this.calling)) return false;
      if (!jp.called.equals(this.called)) return false;
      return true;
   }

   public int hashCode()
   {
      return calling.hashCode() + called.hashCode();
   }

   public Constructor getCalling()
   {
      return calling;
   }

   public Constructor getCalled()
   {
      return called;
   }
}
