/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.joinpoint;

import java.lang.reflect.Constructor;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 */
public class ConstructorJoinpoint implements Joinpoint
{
   private final Constructor constructor;

   public ConstructorJoinpoint(Constructor con)
   {
      this.constructor = con;
   }

   public boolean equals(Object o)
   {
      if (o == null) return false;
      if (o == this) return true;
      if (!(o instanceof ConstructorJoinpoint)) return false;
      ConstructorJoinpoint jp = (ConstructorJoinpoint)o;
      return constructor.equals(jp.constructor);
   }

   public int hashCode()
   {
      return constructor.hashCode();
   }

   public Constructor getConstructor()
   {
      return constructor;
   }
}
