/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.joinpoint;

import java.lang.reflect.Field;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 */
public class FieldJoinpoint implements Joinpoint
{
   private final Field field;

   public FieldJoinpoint(Field field)
   {
      this.field = field;
   }

   public boolean equals(Object o)
   {
      if (o == null) return false;
      if (o == this) return true;
      if (!(o instanceof FieldJoinpoint)) return false;
      FieldJoinpoint jp = (FieldJoinpoint)o;
      return field.equals(jp.field);
   }

   public int hashCode()
   {
      return field.hashCode();
   }

   public Field getField()
   {
      return field;
   }
}
