/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.joinpoint;

import java.lang.reflect.Method;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 */
public class MethodJoinpoint implements Joinpoint
{
   private final Method method;

   public MethodJoinpoint(Method method)
   {
      this.method = method;
   }

   public boolean equals(Object o)
   {
      if (o == null) return false;
      if (o == this) return true;
      if (!(o instanceof MethodJoinpoint)) return false;
      MethodJoinpoint jp = (MethodJoinpoint)o;
      return method.equals(jp.method);
   }

   public int hashCode()
   {
      return method.hashCode();
   }

   public Method getMethod()
   {
      return method;
   }
}
