/***************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ***************************************/

package org.jboss.aop.metadata;

import org.jboss.aop.joinpoint.Invocation;

/**
 * Classes implementing this interface use the
 * context of the Invocation to find metadata
 *
 * For instance, MethodMetaData extracts the Method from
 * the invocation.
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.3 $
 */
public interface MetaDataResolver
{
   /** Name used for empty tag for annotations with no attributes */
   String EMPTY_TAG = "$tagged$";
   
   public Object resolve(Invocation invocation, Object tag, Object attr);

   /**
    * Get all metadata that belong with the context of this invocation
    */
   public SimpleMetaData getAllMetaData(Invocation invocation);
}
