/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.pointcut;

import java.util.ArrayList;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 *
 **/
public class CFlowStack
{
   private String name;
   private ArrayList cflows = new ArrayList();

   public CFlowStack(String name)
   {
      this.name = name;
   }

   public String getName()
   {
      return name;
   }

   public void addCFlow(org.jboss.aop.pointcut.CFlow cflow)
   {
      cflows.add(cflow);
   }

   public boolean matches(StackTraceElement[] stack)
   {
      int stackIndex = stack.length - 1;
      for (int i = 0; i < cflows.size(); i++)
      {
         org.jboss.aop.pointcut.CFlow cflow = (org.jboss.aop.pointcut.CFlow)cflows.get(i);
         stackIndex = cflow.matches(stack, stackIndex);
         if (stackIndex == org.jboss.aop.pointcut.CFlow.NOT_FOUND)
         {
            return false;
         }
         if (stackIndex == -1 && i + 1 < cflows.size()) return false;
      }
      return true;
   }

}
