/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.pointcut;

import javassist.CtField;
import javassist.NotFoundException;
import org.jboss.aop.ClassAdvisor;
import org.jboss.aop.pointcut.ast.ASTGet;
import org.jboss.aop.pointcut.ast.ASTStart;

import java.lang.reflect.Field;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 *
 **/
public class FieldGetMatcher extends FieldMatcher
{
   private CtField ctField;
   private Field field;

   public FieldGetMatcher(ClassAdvisor advisor, CtField field, ASTStart start) throws NotFoundException
   {
      super(advisor, field, start);
      this.ctField = field;
   }

   public FieldGetMatcher(ClassAdvisor advisor, Field field, ASTStart start)
   {
      super(advisor, field, start);
      this.field = field;
   }

   public Object visit(ASTGet node, Object data)
   {
      return node.jjtGetChild(0).jjtAccept(this, null);
   }

   protected Boolean resolvePointcut(Pointcut p)
   {
      if (ctField != null)
      {
         try
         {
            return new Boolean(p.matchesGet(advisor, ctField));
         }
         catch (NotFoundException e)
         {
            throw new RuntimeException(e);  //To change body of catch statement use Options | File Templates.
         }
      }
      else
      {
         return new Boolean(p.matchesGet(advisor, field));
      }
   }
}
