/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aop.pointcut;

import javassist.CtConstructor;
import javassist.CtField;
import javassist.CtMethod;
import javassist.NotFoundException;
import javassist.expr.MethodCall;
import javassist.expr.NewExpr;
import org.jboss.aop.Advisor;
import org.jboss.aop.ClassAdvisor;

import java.lang.reflect.AccessibleObject;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.4 $
 *
 **/
public interface Pointcut
{
   String getName();

   boolean softMatch(Advisor advisor);

   boolean matchesCall(ClassAdvisor callingAdvisor, MethodCall methodCall) throws NotFoundException;

   boolean matchesCall(ClassAdvisor callingAdvisor, NewExpr methodCall) throws NotFoundException;

   boolean matchesExecution(Advisor advisor, Method m);

   boolean matchesExecution(ClassAdvisor advisor, Constructor c);

   boolean matchesExecution(Advisor advisor, CtMethod m) throws NotFoundException;

   boolean matchesExecution(ClassAdvisor advisor, CtConstructor c) throws NotFoundException;

   boolean matchesGet(ClassAdvisor advisor, Field f);

   boolean matchesSet(ClassAdvisor advisor, Field f);

   boolean matchesGet(ClassAdvisor advisor, CtField f) throws NotFoundException;

   boolean matchesSet(ClassAdvisor advisor, CtField f) throws NotFoundException;

   boolean matchesCall(ClassAdvisor advisor, AccessibleObject within, Class calledClass, Method calledMethod);

   boolean matchesCall(ClassAdvisor advisor, AccessibleObject within, Class calledClass, Constructor calledCon);

   String getExpr();

}
