/* *************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ************************************* */
package org.jboss.aop.pointcut;

import javassist.CtClass;
import org.jboss.aop.Advisor;
import org.jboss.aop.ClassAdvisor;
import org.jboss.aop.pointcut.ast.ASTStart;
import org.jboss.aop.pointcut.ast.ParseException;
import org.jboss.aop.pointcut.ast.TypeExpressionParser;

import java.io.StringReader;


/**
 * @author <a href="mailto:kabirkhan@bigfoot.com">Kabir Khan</a>
 *
 */
public class TypedefExpression implements Typedef{
	protected String name;
	protected String expr;
	protected ASTStart ast;

	public TypedefExpression(String name, String expr) throws ParseException
	 {
		 this.name = name;
		 this.expr = expr;

		 ast = new TypeExpressionParser(new StringReader(expr)).Start();
	 }

	 public String getName()
	 {
		 return name;
	 }

	 public String getExpr()
	 {
		 return expr;
	 }

	public boolean matches(Advisor advisor, CtClass clazz)
	{
		TypeMatcher matcher = new TypeMatcher((ClassAdvisor)advisor, clazz);
		return ((Boolean)ast.jjtAccept(matcher, null)).booleanValue();
	}
	
	public boolean matches(Advisor advisor, Class clazz)
	{
		TypeMatcher matcher = new TypeMatcher((ClassAdvisor)advisor, clazz);
		return ((Boolean)ast.jjtAccept(matcher, null)).booleanValue();
	}


}
