/***************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ***************************************/

package org.jboss.aop.util;

import javassist.CtField;

/**
 * Compares CtFields. Used to ensure that the field IDs line up between the
 * instrumentor and advisor.
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1 $
 */
public class CtFieldComparator implements java.util.Comparator {

    private CtFieldComparator() {}

    public static final java.util.Comparator INSTANCE = new CtFieldComparator();
        
    private int compare(CtField m1, CtField m2) {
       return m1.getName().compareTo(m2.getName());
    }

    public int compare(Object o1, Object o2) {
        return compare((CtField) o1, (CtField) o2);
    }

}
