/***************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ***************************************/

package org.jboss.aop.util;

import java.lang.reflect.Field;

/**
 * Compares Fields. This is used to make sure the field IDs line up between
 * the advisor and the instrumentor.
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1 $
 */
public class FieldComparator implements java.util.Comparator {

    private FieldComparator() {}

    public static final java.util.Comparator INSTANCE = new FieldComparator();
        
    private int compare(Field m1, Field m2) {
       return m1.getName().compareTo(m2.getName());
    }

    public int compare(Object o1, Object o2) {
        return compare((Field) o1, (Field) o2);
    }

}
