/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.annotated;

import java.lang.reflect.Field;
import java.lang.reflect.Method;

import org.jboss.aop.joinpoint.FieldReadInvocation;
import org.jboss.aop.joinpoint.FieldWriteInvocation;
import org.jboss.aop.joinpoint.MethodInvocation;

/**
 *
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.1.2.2 $
 * @@org.jboss.aop.InterceptorDef (scope=org.jboss.aop.advice.Scope.PER_VM)
 * @@org.jboss.aop.Bind (pointcut="execution(* org.jboss.test.aop.annotated.POJO*->methodWithInterceptorFactory())")
 */
public class CountingInterceptor implements org.jboss.aop.advice.Interceptor
{

   public String getName()
   {
      return "CountingInterceptor";
   }

   public Object invoke(org.jboss.aop.joinpoint.Invocation invocation) throws Throwable
   {
      System.out.println("CountingInterceptor interception: " + invocation.getClass().getName());
      count++;
      return invocation.invokeNext();
   }

   public static int count;
}

