/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.annotated;

import org.jboss.aop.Advisor;
import org.jboss.aop.InstanceAdvisor;
import org.jboss.aop.advice.AspectFactory;
import org.jboss.aop.joinpoint.Joinpoint;

/**
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1.2.2 $
 * @@org.jboss.aop.InterceptorDef (scope=org.jboss.aop.advice.Scope.PER_VM)
 * @@org.jboss.aop.Bind (pointcut="execution(* org.jboss.test.aop.annotated.POJO*->methodWithInterceptor())")
 */
public class CountingInterceptorFactory implements AspectFactory
{
   public Object createPerVM()
   {
      return new CountingInterceptor();
   }

   public Object createPerClass(Advisor advisor)
   {
      return new CountingInterceptor();
   }

   public Object createPerInstance(Advisor advisor, InstanceAdvisor instanceAdvisor)
   {
      return new CountingInterceptor();
   }

   public Object createPerJoinpoint(Advisor advisor, Joinpoint jp)
   {
      return new CountingInterceptor();
   }

   public Object createPerJoinpoint(Advisor advisor, InstanceAdvisor instanceAdvisor, Joinpoint jp)
   {
      return new CountingInterceptor();
   }

   public String getName()
   {
      return getClass().getName();
   }
}

