/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.annotated;

import org.apache.tools.ant.taskdefs.Typedef;
import org.jboss.aop.introduction.InterfaceIntroduction;

/**
 *
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.3.2.2 $
 * @@org.jboss.aop.Aspect (scope=org.jboss.aop.advice.Scope.PER_VM)
 */

public class IntroductionAspect
{
   /**
    * @@org.jboss.aop.Introduction (target=org.jboss.test.aop.annotated.POJONoInterfaces, interfaces={org.jboss.test.aop.annotated.EmptyInterface})
    */
   public static InterfaceIntroduction pojoNoInterfacesIntro;

   /**
    * @@org.jboss.aop.Introduction (typeExpression="has(* *->pojoInterfaces2Method(..))", interfaces={org.jboss.test.aop.annotated.EmptyInterface})
    */
   public static InterfaceIntroduction pojoNoInterfaces2Intro;

   /**
    * @@org.jboss.aop.Mixin (target=org.jboss.test.aop.annotated.POJONoInterfaces, interfaces={java.io.Externalizable})
    */
   public static ExternalizableMixin createExternalizableMixin(POJONoInterfaces pojo) {
       return new ExternalizableMixin(pojo);
   }
   /**
    * @@org.jboss.aop.Mixin (typeExpression="has(* *->pojoInterfaces2Method(..))", interfaces={java.io.Externalizable})
    */
   public static ExternalizableMixin createExternalizableMixin2(POJONoInterfaces pojo) {
       return new ExternalizableMixin(pojo);
   }
   
}
