/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.basic;

import java.io.NotSerializableException;

/**
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1.2.3 $
 */
public class POJO
{

   private int privateField = 5;
   protected int protectedField = 5;
   public static int staticField = 5;
   private String remoteValue;
   private boolean foo;

   public POJO()
   {
   }


   public POJO(String s)
   {
      System.out.println("POJO Constructor: " + s);
      remoteValue = s;
   }
   
   public POJO(int i) throws SomeException, ClassCastException
   {
      System.out.println("POJO Constructor: " + i);
   }

   public void someMethod()
   {
      System.out.println("POJO.someMethod");
   }

   public void anotherMethod()
   {
      System.out.println("POJO.anotherMethod");
   }

   public static void staticMethod()
   {
      System.out.println("POJO.staticMethod");
   }

   public void accessField()
   {
      privateField += 1;
      System.out.println("privateField = " + privateField);
   }

   public void accessStaticField()
   {
      staticField += 1;
      System.out.println("staticField = " + staticField);
   }

   public String remoteTest()
   {
      return remoteValue;
   }

   public void throwException() throws SomeException
   {
      throw new SomeException();
   }
   
   public void withSomeException() throws SomeException
   {
      System.out.println("POJO.withSomeException");
   }

   public void withExceptionAndOthers(String s) throws SomeException, NotSerializableException
   {
      System.out.println("POJO.withExceptionAndOthers");
   }
   
   public void withExceptionAndOthers(int i) throws SomeException, NotSerializableException
   {
      System.out.println("POJO.withExceptionAndOthers");
   }
   
   public void withClassCastException(int i) throws SomeException, NotSerializableException, ClassCastException
   {
      System.out.println("POJO.withClassCastException");
   }
   
}

