/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.basic;

import org.jboss.aop.advice.Interceptor;
import org.jboss.aop.joinpoint.Invocation;

/**
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1 $
 */
public class POJOConstructorInterceptor implements Interceptor
{

   public String getName()
   {
      return "POJOConstructorInterceptor";
   }

   public Object invoke(Invocation invocation) throws Throwable
   {
      Object rtn = invocation.invokeNext();
      POJOConstructorTest pojo = (POJOConstructorTest) rtn;
      String data = (String) invocation.getMetaData("test", "data");
      System.out.println("POJOConstructorInterceptor's data is: " + data);
      pojo.data = data;
      return pojo;
   }

}

