/* *************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ************************************* */
package org.jboss.test.aop.basic;

/**
 * @author <a href="mailto:kabirkhan@bigfoot.com">Kabir Khan</a>
 * @version $Revision: 1.1 $
 */
public class PrivateProtectedPOJO
{

   protected PrivateProtectedPOJO()
   {
      System.out.println("PrivateProtectedPOJO protected constructor");
   }

   private PrivateProtectedPOJO(String s)
   {
      System.out.println("PrivateProtectedPOJO private constructor");
   }

   public PrivateProtectedPOJO(String s, int i)
   {
      System.out.println("PrivateProtectedPOJO public constructor");
      PrivateProtectedPOJO pojo = new PrivateProtectedPOJO(s);
   }

   private void privateMethod()
   {
      System.out.println("PrivateProtectedPOJO.privateMethod");
   }

   protected void protectedMethod()
   {
      System.out.println("PrivateProtectedPOJO.protectedMethod");
   }

   private static void privateStaticMethod()
   {
      System.out.println("PrivateProtectedPOJO.privateStaticMethod");
   }

   protected static void protectedStaticMethod()
   {
      System.out.println("PrivateProtectedPOJO.protectedStaticMethod");
   }

   public void callProtectedMethod()
   {
      protectedMethod();
   }

   public void callPrivateMethod()
   {
      privateMethod();
   }


   public static void callPrivateStaticMethod()
   {
      privateStaticMethod();
   }

   public static void callProtectedStaticMethod()
   {
      protectedStaticMethod();
   }

   public static void callPrivateConstructor()
   {
      PrivateProtectedPOJO pojo = new PrivateProtectedPOJO("s");
   }
}
