/* *************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ************************************* */
package org.jboss.test.aop.basic;

import org.jboss.aop.joinpoint.Invocation;
import org.jboss.aop.reflection.ReflectionAspect;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;

/**
 * @author <a href="mailto:kabirkhan@bigfoot.com">Kabir Khan</a>
 */

public class ReflectionAspectTester extends ReflectionAspect
{

   public static Constructor constructor;
   public static Field field;
   public static Object[] args;
   public static Object retObj;

   public static void clear()
   {
      ReflectionAspectTester.constructor = null;
      ReflectionAspectTester.field = null;
      ReflectionAspectTester.args = null;
      ReflectionAspectTester.retObj = null;
   }

   protected Object interceptConstructor(Invocation invocation,
                                         Constructor constructor,
                                         Object[] args)
           throws Throwable
   {

      clear();
      ReflectionAspectTester.constructor = constructor;
      ReflectionAspectTester.args = args;

      ReflectionAspectTester.retObj = super.interceptConstructor(invocation, constructor, args);
      return ReflectionAspectTester.retObj;
   }

   protected Object interceptFieldRead(Invocation invocation,
                                       Field field,
                                       Object instance)
           throws Throwable
   {

      clear();
      ReflectionAspectTester.field = field;
      ReflectionAspectTester.retObj = super.interceptFieldRead(invocation, field, instance);
      return ReflectionAspectTester.retObj;
   }

   protected Object interceptFieldWrite(Invocation invocation,
                                        Field field,
                                        Object instance,
                                        Object arg)
           throws Throwable
   {

      clear();
      ReflectionAspectTester.field = field;
      ReflectionAspectTester.args = new Object[]{arg};
      ReflectionAspectTester.retObj = super.interceptFieldWrite(invocation, field, instance, arg);
      return ReflectionAspectTester.retObj;
   }
}
