/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.beanstyleconfig;

import org.jboss.aop.Advisor;
import org.jboss.aop.InstanceAdvisor;
import org.jboss.aop.joinpoint.Invocation;
import org.jboss.aop.joinpoint.Joinpoint;

/**
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.1 $
 */
public class AdvicePerJoinpoint
{
   private int intAttr;
   private String stringAttr;
   private Advisor advisor;
   private InstanceAdvisor instanceAdvisor;
   private Joinpoint joinpoint;


   /**
    * @return Returns the advisor.
    */
   public Advisor getAdvisor()
   {
      return advisor;
   }

   /**
    * @param advisor The advisor to set.
    */
   public void setAdvisor(Advisor advisor)
   {
      this.advisor = advisor;
   }

   /**
    * @return Returns the instanceAdvisor.
    */
   public InstanceAdvisor getInstanceAdvisor()
   {
      return instanceAdvisor;
   }

   /**
    * @param instanceAdvisor The instanceAdvisor to set.
    */
   public void setInstanceAdvisor(InstanceAdvisor instanceAdvisor)
   {
      this.instanceAdvisor = instanceAdvisor;
   }

   /**
    * @return Returns the intAttr.
    */
   public int getIntAttr()
   {
      return intAttr;
   }

   /**
    * @param intAttr The intAttr to set.
    */
   public void setIntAttr(int intAttr)
   {
      this.intAttr = intAttr;
   }

   /**
    * @return Returns the joinpoint.
    */
   public Joinpoint getJoinpoint()
   {
      return joinpoint;
   }

   /**
    * @param joinpoint The joinpoint to set.
    */
   public void setJoinpoint(Joinpoint joinpoint)
   {
      this.joinpoint = joinpoint;
   }

   /**
    * @return Returns the stringAttr.
    */
   public String getStringAttr()
   {
      return stringAttr;
   }

   /**
    * @param stringAttr The stringAttr to set.
    */
   public void setStringAttr(String stringAttr)
   {
      this.stringAttr = stringAttr;
   }

   public Object invoke(Invocation invocation) throws Throwable
   {
      InvokedConfigs.addInvokedConfig(this.getClass().getName(), advisor, instanceAdvisor, joinpoint, intAttr, stringAttr);
      return invocation.invokeNext();
   }
}
