/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.introduction;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import java.rmi.MarshalledObject;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1.2.1 $
 */
public class IntroductionTester extends TestCase
{
   public static Test suite()
   {
      TestSuite suite = new TestSuite("IntroductionTester");
      suite.addTestSuite(IntroductionTester.class);
      return suite;
   }
   // Constants ----------------------------------------------------
   // Attributes ---------------------------------------------------

   // Static -------------------------------------------------------

   // Constructors -------------------------------------------------
   public IntroductionTester(String name)
   {
      super(name);
   }

   public void testSerialization() throws Exception
   {
      SerializedPOJO pojo = new SerializedPOJO();
      ((NonSerializedIntroduction) pojo).setNonMessage("hello");
      ((SerializedIntroduction) pojo).setMessage("world");

      if (!((NonSerializedIntroduction) pojo).getNonMessage().equals("hello")) throw new Exception("non serialized isn't set correctly");
      if (!((SerializedIntroduction) pojo).getMessage().equals("world")) throw new Exception("serialized isn't set correctly");

      MarshalledObject mo = new MarshalledObject(pojo);
      pojo = (SerializedPOJO) mo.get();

      if (!((NonSerializedIntroduction) pojo).getNonMessage().equals("original")) throw new Exception("non serialized isn't set correctly" + ((NonSerializedIntroduction) pojo).getNonMessage().equals("original"));
      if (!((SerializedIntroduction) pojo).getMessage().equals("world")) throw new Exception("serialized isn't set correctly");

      assertTrue(((NonSerializedIntroduction) pojo)._testUnderscore());


   }
}
