/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.jdk15;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.textui.TestRunner;

/**
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 */
public class AOPTester extends TestCase
{
   public static void main(String[] args)
   {
      TestRunner.run(suite());
   }

   private void printComplex(complex c)
   {
      System.out.print("@complex (ch='" + c.ch() + "', ");
      System.out.print("\"" + c.string() + "\", ");
      System.out.print("flt=" + c.flt() + ", ");
      System.out.print("enumVal=" + c.enumVal() + ", ");
      System.out.println("dbl=" + c.dbl() + ", ...blah blah blah YOU GET THE IDEA...");

   }

   public static Test suite()
   {
      TestSuite suite = new TestSuite("AOPTester");
      suite.addTestSuite(AOPTester.class);
      return suite;
   }

   public AOPTester(String name)
   {
      super(name);
   }

   // Public -------------------------------------------------------

   public void testAnnotation()
   {
      System.out.println("RUNNING TEST BASIC");

      SimpleInterceptor.intercepted = false;
      AnnotatedPOJO pojo = new AnnotatedPOJO();
      if (!SimpleInterceptor.intercepted) throw new RuntimeException("failed to intercept tagged constructor");

      complex c = (complex) AnnotatedPOJO.class.getAnnotation(complex.class);
      printComplex(c);

      SimpleInterceptor.intercepted = false;
      pojo = new AnnotatedPOJO("no interception");
      if (SimpleInterceptor.intercepted) throw new RuntimeException("should not intercept non-tagged constructor");

      pojo.someMethod();
      if (!SimpleInterceptor.intercepted) throw new RuntimeException("failed to intercept tagged method");

      SimpleInterceptor.intercepted = false;
      pojo.nontraceableMethod();
      if (SimpleInterceptor.intercepted) throw new RuntimeException("should not intercept non-tagged method");

      pojo.field = 5;
      if (!SimpleInterceptor.intercepted) throw new RuntimeException("failed to intercept tagged field");

      SimpleInterceptor.intercepted = false;
      pojo.nontraceable = 25;
      if (SimpleInterceptor.intercepted) throw new RuntimeException("should not intercept non-tagged field");

      Introduction intro = (Introduction) pojo;
      intro.helloWorld("hello");
   }
}

