/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.jdk15.annotated;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

/**
 *
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.1.2.2 $
 */
public class ExternalizableMixin implements Externalizable
{
   public static boolean read = false;
   public static boolean write = false;

   POJONoInterfaces pojo;
   
   public ExternalizableMixin(POJONoInterfaces pojo)
   {
      System.out.println("ExternalizableMixin constructor");
      this.pojo = pojo;
   }

   public void readExternal(ObjectInput in) throws IOException, ClassNotFoundException
   {
      System.out.println("ExternalizableMixin readExternal");
      read = true;
      pojo.stuff = in.readUTF();  
   }
   
   public void writeExternal(ObjectOutput out) throws IOException
   {
      System.out.println("ExternalizableMixin writeExternal");
      write = true;
      out.writeUTF(pojo.stuff);
   }
   
   
}
