/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.jdk15.annotated;

import org.jboss.aop.Mixin;
import org.jboss.aop.Introduction;
import org.jboss.aop.Aspect;
/**
 *
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.4.2.2 $
 */
@Aspect (scope=org.jboss.aop.advice.Scope.PER_VM)
public class IntroductionAspect
{
   @Mixin (target=org.jboss.test.aop.jdk15.annotated.POJONoInterfaces.class, interfaces={java.io.Externalizable.class})
   public static ExternalizableMixin createExternalizableMixin(POJONoInterfaces pojo) {
       return new ExternalizableMixin(pojo);
   }
   
   @Introduction (target=org.jboss.test.aop.jdk15.annotated.POJONoInterfaces.class, interfaces={org.jboss.test.aop.jdk15.annotated.EmptyInterface.class})
   public static Object pojoNoInterfacesIntro;

   @Mixin (typeExpression="has(* *->pojoInterfaces2Method(..))", interfaces={java.io.Externalizable.class}, isTransient=false)
   public static ExternalizableMixin createExternalizableMixin2(POJONoInterfaces pojo) {
       return new ExternalizableMixin(pojo);
   }
   
   @Introduction (typeExpression="has(* *->pojoInterfaces2Method(..))", interfaces={org.jboss.test.aop.jdk15.annotated.EmptyInterface.class})
   public static Object pojoNoInterfaces2Intro;

}
