/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.jdk15.annotated;

import org.jboss.aop.Aspect;
import org.jboss.aop.Bind;
import org.jboss.aop.TypeDef;
import org.jboss.aop.pointcut.Typedef;
import org.jboss.aop.joinpoint.Invocation;


/**
 *
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.2.2.2 $
*/
@Aspect (scope=org.jboss.aop.advice.Scope.PER_VM)
public class TypedefAspect
{
   public static boolean intercepted;

   @TypeDef ("class(org.jboss.test.aop.jdk15.annotated.POJO)")
   public static Typedef myTypedef;

    @Bind (pointcut="execution(* $typedef{org.jboss.test.aop.jdk15.annotated.TypedefAspect.myTypedef}->methodWithTypedef())")
    public Object typedefAdvice(Invocation invocation) throws Throwable
   {
      intercepted = true;
      return invocation.invokeNext();
   }
}
