/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.reflection;

import org.jboss.aop.advice.Interceptor;

/**
 *
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.1.2.1 $
 */
public class CallerInterceptor implements Interceptor
{
   public static int intercepted;
   public String getName()
   {
      return "CallerInterceptor";
   }

   public Object invoke(org.jboss.aop.joinpoint.Invocation invocation) throws Throwable
   {
      System.out.println("CallerInterceptor interception: " + invocation.getClass().getName());
      intercepted++;
      return invocation.invokeNext();
   }
   
   public static void reset()
   {
      intercepted = 0;
   }
}
