/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.reflection;

import java.io.NotSerializableException;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.jboss.aop.Advised;
import org.jboss.aop.InstanceAdvisor;

/**
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.1.2.1 $
 */
public class ReflectionTester extends TestCase
{
   ReflectionPOJO reflectionPOJO;
   public static Test suite()
   {
      TestSuite suite = new TestSuite("ReflectionTester");
      suite.addTestSuite(ReflectionTester.class);
      return suite;
   }
   // Constants ----------------------------------------------------
   // Attributes ---------------------------------------------------

   // Static -------------------------------------------------------

   // Constructors -------------------------------------------------
   public ReflectionTester(String name)
   {
      super(name);
   }

   // Public -------------------------------------------------------

   public void testAccessFromConstructor()
   {
      System.out.println("RUNNING TEST ACCESS FROM CONSTRUCTOR");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO(1);
   }
   
   public void testAccessFromMethod()
   {
      System.out.println("RUNNING TEST ACCESS FROM METHOD");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO();
      reflectionPOJO.testCreationAndFieldAccess();
   }
   
   public void testCleanGetMethods()
   {
      System.out.println("RUNNING TEST CLEAN GET METHODS");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO();
      reflectionPOJO.testCleanGetMethods();
   }
   
   public void testCleanGetDeclaredMethods()
   {
      System.out.println("RUNNING TEST CLEAN GET DECLARED METHODS");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO();
      reflectionPOJO.testCleanGetDeclaredMethods();
   }
   
   public void testCleanGetDeclaredFields()
   {
      System.out.println("RUNNING TEST CLEAN GET DECLARED FIELDS");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO();
      reflectionPOJO.testCleanGetDeclaredFields();
   }
   
   public void testCleanGetInterfaces()
   {
      System.out.println("RUNNING TEST CLEAN GET INTERFACES");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO();
      reflectionPOJO.testCleanGetInterfaces();
   }
   
   public void testCleanGetDeclaredMethod()
   {
      System.out.println("RUNNING TEST CLEAN GET DECLARED METHOD");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO();
      reflectionPOJO.testCleanGetDeclaredMethod();
   }
   
   public void testCleanGetDeclaredField()
   {
      System.out.println("RUNNING TEST CLEAN GET DECLARED FIELD");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO();
      reflectionPOJO.testCleanGetDeclaredField();
   }
   
   public void testCleanGetMethod()
   {
      System.out.println("RUNNING TEST CLEAN GET METHOD");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO();
      reflectionPOJO.testCleanGetMethod();
   }
   
   public void testCleanGetClasses()
   {
      System.out.println("RUNNING TEST CLEAN GET CLASSES");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO();
      reflectionPOJO.testCleanGetClasses();
   }
   
   public void testCleanGetDeclaredClasses()
   {
      System.out.println("RUNNING TEST CLEAN GET DECLARED CLASSES");
      ReflectionPOJO reflectionPOJO = new ReflectionPOJO();
      reflectionPOJO.testCleanGetDeclaredClasses();
   }
   

   // Inner classes -------------------------------------------------
}

