/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.aop.regression.statictest;


import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Tests that static is used correctly
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1 $
 */
public class AOPTester extends TestCase
{
   public static Test suite()
   {
      TestSuite suite = new TestSuite("AOPTester");
      suite.addTestSuite(AOPTester.class);
      return suite;
   }

   public AOPTester(String name)
   {
      super(name);
   }

   public void testRegression()
   {
      MemberOnly mo = new MemberOnly();
      SimpleInterceptor.called = false;
      mo.memberMethod();
      if (SimpleInterceptor.called != true) throw new RuntimeException("MemberOnly did not get intercepted");
      SimpleInterceptor.called = false;
      MemberOnly.staticMethod();
      if (SimpleInterceptor.called == true) throw new RuntimeException("MemberOnly static method DID get intercepted");

      StaticOnly so = new StaticOnly();
      SimpleInterceptor.called = false;
      so.memberMethod();
      if (SimpleInterceptor.called == true) throw new RuntimeException("StaticOnly member method got intercepted!");
      SimpleInterceptor.called = false;
      StaticOnly.staticMethod();
      if (SimpleInterceptor.called == false) throw new RuntimeException("StaticOnly static method DID NOT get intercepted");

   }

}

