/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

// $Id: JBossAopSubTask.java,v 1.2 2003/07/02 19:25:09 andygodwin Exp $

package xdoclet.modules.jboss.aop;

import xdoclet.XmlSubTask;

/**
 * JBossAopSubTask is an xml-based XDoclet sub task for generation of
 * jboss-aop.xml AOP deployment descriptors
 *
 * @ant.element display-name="JBossAOP" name="jbossaop"
 *              parent="xdoclet.modules.jboss.aop.JBossAopTask"
 *
 * @author <a href="mailto:andy_godwin@hotmail.com">Andy Godwin</a>
 * @created May 28, 2003
 * @version $Revision: 1.2 $
 */
public class JBossAopSubTask
       extends XmlSubTask
{
   public final static String SUBTASK_NAME = "jbossaop";

   private final static String JBOSSAOP_DTD =
      "http://www.jboss.org/j2ee/dtd/jbossaop.dtd";
   private static String DEFAULT_TEMPLATE_FILE =
      "xdoclet/modules/jboss/aop/resources/jboss-aop.xdt";
   private static String GENERATED_FILE_NAME = "jboss-aop.xml";
   private static String CLASS_TAG = "jboss-aop";

   public JBossAopSubTask()
   {
      setTemplateURL(
         getClass().getClassLoader().getResource(DEFAULT_TEMPLATE_FILE));
      setDestinationFile(GENERATED_FILE_NAME);
      setHavingClassTag(CLASS_TAG);
      setValidateXML(false);
      setSubTaskName(SUBTASK_NAME);
   }
}


