/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

// $Id: JBossFieldTagsHandler.java,v 1.1 2003/06/05 21:53:23 andygodwin Exp $

package xdoclet.modules.jboss.aop;

import java.util.Properties;
import xdoclet.tagshandler.FieldTagsHandler;
import xdoclet.XDocletException;

/**
 * JBossFieldTagsHandler simply adds a couple of template methods missing
 * from the existing XDoclet FieldTagsHandler.
 *
 * @author <a href="mailto:andy_godwin@hotmail.com">Andy Godwin</a>
 * @created May 28, 2003
 * @version $Revision: 1.1 $
 */
public class JBossFieldTagsHandler
       extends FieldTagsHandler
{
   /**
    * An XDoclet content template tag handler that executes the enclosing
    * template if the specified tag attribute value for the current field is
    * NOT equal to the supplied value.
    */
   public void ifFieldTagValueNotEquals(String template, Properties attributes)
          throws XDocletException
   {
      if (!isTagValueEqual(attributes, FOR_FIELD))
      {
         generate(template);
      }
   }

   /**
    * An XDoclet content template tag handler that executes the enclosing
    * template if the specified tag attribute value for the current field does
    * NOT exist.
    */
   public void ifDoesntHaveFieldTag(String template, Properties attributes)
          throws XDocletException
   {
      if (!hasTag(attributes, FOR_FIELD))
      {
         generate(template);
      }
   }
}
