/*
 * Read Write Lock Pattern .
 *
 * Copyright (C) 2004 Claude Hussenet
 * Contact : chussenet@yahoo.com
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package test.patterns.readwritelock;
/**
 * @version <tt>$Revision: 1.1 $</tt>
 * @author  <a href="mailto:chussenet@yahoo.com">{Claude Hussenet Independent Consultant}</a>.
 */
public class Driver
{

   public static void main(String[] args)
   {

	Account accountWithoutReadWriteLock = new Account(1000);
	processReadWriteLockPattern(accountWithoutReadWriteLock);
	System.out.println("Balance should be $1000 !");
    System.out.println("Concurrent Read/Write without Aspect: $"+accountWithoutReadWriteLock.getBalance());

  	Account accountWithReadWriteLock = new AccountWithReadWriteLock(1000);
	processReadWriteLockPattern(accountWithReadWriteLock);
    System.out.println("Concurrent Read/Write with Aspect: $"+accountWithReadWriteLock.getBalance());
   }

   public static void processReadWriteLockPattern(Account account)
   {

     new Thread(new ProcessTransaction(account,100)).start();
     new Thread(new ProcessTransaction(account,300)).start();
     new Thread(new ProcessTransaction(account,-150)).start();
     new Thread(new ProcessTransaction(account,-250)).start();

     try
     {
		 Thread.currentThread().sleep(500);
     }
     catch (Exception e){}


   }












}
