/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aspects;

import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
import java.lang.annotation.ElementType;

/**
 * This is an annotation.
 *
 * This annotation is used to inject something that is thread based
 * could be used for current transaction, current security context, etc...
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1 $
 */
@Target({ElementType.FIELD}) @Retention(RetentionPolicy.RUNTIME)
public @interface Current
{
}
