/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aspects.security;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * JDK 1.4 annotation for JBoss security domain
 *
 * See JBoss J2EE Security documentation for more info on security domains.
 * Basically it specifies the repository where usernames, passwords, and 
 * user/role associtations are stored.
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 *
 **/
@Target({ElementType.TYPE}) @Retention(RetentionPolicy.RUNTIME)
public @interface SecurityDomain
{
   String value();
}
