/*

 * Asynchronous Engine .

 * 

 * Copyright (C) 2004 Claude Hussenet

 * Contact : chussenet@yahoo.com

 * 

 * Distributable under LGPL license.

 * See terms of license at gnu.org.

 */

package org.jboss.aspects.asynchronous.aspects;

import org.jboss.aspects.asynchronous.AsynchronousResponse;
import org.jboss.aspects.asynchronous.AsynchronousTask;
import org.jboss.aspects.asynchronous.ThreadManagerResponse;

/**
 * @author <a href="mailto:chussenet@yahoo.com">{Claude Hussenet Independent Consultant}</a>.
 * @version <tt>$Revision: 1.2 $</tt>
 */

public interface AsynchronousFacade
{


   public void setId(String id);

   public String getId();


   public void setTimeout(long timeout);

   public long getTimeout();


   public AsynchronousTask getAsynchronousTask();

   public void setAsynchronousTask(AsynchronousTask asynchronousTask);


   public ThreadManagerResponse getThreadManagerResponse();


   public AsynchronousResponse waitForResponse();

   public boolean isDone();

   public int getResponseCode();

   public Object getReturnValue();


   public AsynchronousResponse waitForResponse(AsynchronousTask asynchronousTask);

   public boolean isDone(AsynchronousTask asynchronousTask);

   public int getResponseCode(AsynchronousTask synchronousTask);

   public Object getReturnValue(AsynchronousTask asynchronousTask);

}
