/*

 * Asynchronous Engine .

 * 

 * Copyright (C) 2004 Claude Hussenet

 * Contact : chussenet@yahoo.com

 * 

 * Distributable under LGPL license.

 * See terms of license at gnu.org.

 */

package org.jboss.aspects.asynchronous.aspects;

import org.jboss.aspects.asynchronous.AsynchronousTask;

/**
 * @author <a href="mailto:chussenet@yahoo.com">{Claude Hussenet Independent Consultant}</a>.
 * @version <tt>$Revision: 1.2 $</tt>
 */

public class AsynchronousFacadeFieldsThreadLocalImpl

implements AsynchronousFacadeFields
{

   private ThreadLocal threadLocal = new ThreadLocal();

   public AsynchronousFacadeFieldsThreadLocalImpl()
   {

      init();

   }

   private void init()
   {

      threadLocal.set(new AsynchronousFacadeFieldsImpl());

   }

   private AsynchronousFacadeFields getValue()
   {

      if (threadLocal.get() == null)

         init();

      return (AsynchronousFacadeFields) threadLocal.get();

   }

   public String getId()
   {

      return getValue().getId();

   }

   public void setId(String id)
   {

      getValue().setId(id);

   }

   public long getTimeout()
   {

      return getValue().getTimeout();

   }

   public void setTimeout(long timeout)
   {

      getValue().setTimeout(timeout);

   }

   public AsynchronousTask getAsynchronousTask()
   {

      return getValue().getAsynchronousTask();

   }

   public void setAsynchronousTask(AsynchronousTask asynchronousTask)
   {

      getValue().setAsynchronousTask(asynchronousTask);

   }

}

