/*

 * Asynchronous Engine .

 * 

 * Copyright (C) 2004 Claude Hussenet

 * Contact : chussenet@yahoo.com

 * 

 * Distributable under LGPL license.

 * See terms of license at gnu.org.

 */

package org.jboss.aspects.asynchronous.common;

import org.jboss.aspects.asynchronous.AsynchronousTask;
import org.jboss.aspects.asynchronous.ThreadManagerResponse;

/**
 * @author <a href="mailto:chussenet@yahoo.com">{Claude Hussenet Independent Consultant}</a>.
 * @version <tt>$Revision: 1.2 $</tt>
 */

public class AsynchronousEmptyTask implements AsynchronousTask
{

   protected String id;

   protected ThreadManagerResponse threadManagerResponse;

   public AsynchronousEmptyTask(String id,

                                int code,

                                Object e,

                                String reason,

                                long startingTime)
   {

      this.id = id;

      threadManagerResponse =

      new ThreadManagerResponseImpl(id,

      code,

      reason,

      e,

      startingTime,

      startingTime);

   }

   public ThreadManagerResponse getResponse()
   {

      return threadManagerResponse;

   }

   public boolean isDone()
   {

      return true;

   }

   public String getId()
   {

      return id;

   }

}

