/*

 * Asynchronous Engine .

 * 

 * Copyright (C) 2004 Claude Hussenet

 * Contact : chussenet@yahoo.com

 * 

 * Distributable under LGPL license.

 * See terms of license at gnu.org.

 */

package org.jboss.aspects.asynchronous.common;

import org.jboss.aspects.asynchronous.AsynchronousConstants;
import org.jboss.aspects.asynchronous.ThreadManagerResponse;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author <a href="mailto:chussenet@yahoo.com">{Claude Hussenet Independent Consultant}</a>.
 * @version <tt>$Revision: 1.2 $</tt>
 */

public class ThreadManagerResponseImpl

extends AsynchronousResponseImpl

implements ThreadManagerResponse, AsynchronousConstants
{

   private long _startingTime = -1;

   private long _endingTime = -1;

   private String id = null;

   static private SimpleDateFormat formatter =

   new SimpleDateFormat("HH:mm:ss.SSS ");

   public ThreadManagerResponseImpl(String id,

                                    int code,

                                    String reason,

                                    Object obj)
   {

      super(code, reason, obj);

      this.id = id;

   }

   public ThreadManagerResponseImpl(String id,

                                    int code,

                                    String reason,

                                    Object obj,

                                    long startTime)
   {

      super(code, reason, obj);

      _startingTime = startTime;

      this.id = id;

   }

   public ThreadManagerResponseImpl(String id,

                                    int code,

                                    String reason,

                                    Object obj,

                                    long startTime,

                                    long endTime)
   {

      super(code, reason, obj);

      _startingTime = startTime;

      _endingTime = endTime;

      this.id = id;

   }

   public long getStartingTime()
   {

      return _startingTime;

   }

   public long getEndingTime()
   {

      return _endingTime;

   }

   public String toString()
   {

      return new StringBuffer("Id:")

      .append(getId())

      .append(" Rc:")

      .append(getResponseCode())

      .append(getReason() != null ? " Re:" : "")

      .append(getReason() != null ? getReason() : "")

      .append(" St:")

      .append(formatter.format(new Date(getStartingTime())))

      .append(" Du:")

      .append(getEndingTime() - getStartingTime())

      .append(getResponseCode() != AsynchronousConstants.OK ? " Rs:" : "")

      .append(getResult())

      .toString();

   }

   public String getId()
   {

      return id;

   }

}

