/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aspects.ioc;

/**
 * Comment
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1 $
 *
 **/
public class Identifier
{
   public Identifier(String name, Class injectedType)
   {
      this.name = name;
      this.injectedType = injectedType;
   }

   /** name of property **/
   public String name;

   /** used to determine parameter type of set method */
   public Class injectedType;

   public int hashCode() { return name.hashCode() + injectedType.hashCode(); }

   public boolean equals(Object obj)
   {
      if (obj == this) return true;
      if (!(obj instanceof Identifier)) return false;
      Identifier compare = (Identifier)obj;
      if (!compare.name.equals(name)) return false;
      if (!compare.injectedType.equals(injectedType)) return false;
      return true;
   }
}
