/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aspects.logging;

import org.jboss.aop.Advisor;
import org.jboss.aop.InstanceAdvisor;
import org.jboss.aop.joinpoint.Joinpoint;

/**
 * @author  <a href="mailto:adrian@jboss.org">Adrian Brock</a>.
 * @version $Revision: 1.4 $
 */
public class InvocationLogInterceptorFactory
   implements org.jboss.aop.advice.AspectFactory
{
   private static final InvocationLogInterceptor instance = new InvocationLogInterceptor();

   public Object createPerVM()
   {
      return instance;
   }

   public Object createPerClass(Advisor advisor)
   {
      return instance;
   }

   public Object createPerInstance(Advisor advisor, InstanceAdvisor instanceAdvisor)
   {
      return instance;
   }

   public Object createPerJoinpoint(Advisor advisor, Joinpoint jp)
   {
      return instance;
   }

   public Object createPerJoinpoint(Advisor advisor, InstanceAdvisor instanceAdvisor, Joinpoint jp)
   {
      return instance;
   }
   public String getName()
   {
      return getClass().getName();
   }
}
