/*
 * JBoss, the OpenSource J2EE webOS
 * 
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aspects.patterns.observable;

/**
 * An Observer. Implement this interface to register
 * for subject changes.
 * 
 * @author <a href="adrian@jboss.com">Adrian Brock</a>
 * @version $Revision: 1.1 $
 */
public interface Observer
{
   /**
    * Notification that a subject has changed
    * 
    * @param subject the subject
    */
   void fireChange(Subject subject);
}
