/*
 * Read Write Lock Pattern .
 *
 * Copyright (C) 2004 Claude Hussenet
 * Contact : chussenet@yahoo.com
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aspects.patterns.readwritelock;


import EDU.oswego.cs.dl.util.concurrent.ReadWriteLock;
import EDU.oswego.cs.dl.util.concurrent.ReentrantWriterPreferenceReadWriteLock;
import org.jboss.aop.joinpoint.MethodInvocation;

/**
 * @version <tt>$Revision: 1.2 $</tt>
 * @author  <a href="mailto:chussenet@yahoo.com">{Claude Hussenet Independent Consultant}</a>.
 */
public class ReadWriteLockAspect
{

   private ReadWriteLock readWriteLock = new ReentrantWriterPreferenceReadWriteLock();

   public ReadWriteLockAspect()
   {

   }

   public Object readLockMethod(MethodInvocation invocation) throws Throwable
   {
      Object result=null;

      try
      {
         readWriteLock.readLock().acquire();
         result= invocation.invokeNext();
      }
      finally
      {
   		readWriteLock.readLock().release();
      }
      return result;
   }

   public Object writeLockMethod(MethodInvocation invocation) throws Throwable
   {
      Object result = null;

      try
      {
         readWriteLock.writeLock().acquire();
         result= invocation.invokeNext();
      }
      finally
      {
   		readWriteLock.writeLock().release();
      }
     return result;
   }

}
