/***************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ***************************************/

package org.jboss.aspects.remoting;

import org.jboss.ha.framework.interfaces.ClusteringTargetsRepository;
import org.jboss.ha.framework.interfaces.FamilyClusterInfo;

import java.io.IOException;
import java.util.ArrayList;
/**
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 */
public class FamilyWrapper implements java.io.Externalizable
{
   private FamilyClusterInfo info;

   public FamilyWrapper() {}

   public FamilyWrapper(String proxyFamilyName, ArrayList targets)
   {
      info = ClusteringTargetsRepository.initTarget(proxyFamilyName, targets);
   }

   public FamilyClusterInfo get() { return info; }

   public void writeExternal(final java.io.ObjectOutput out)
      throws IOException
   {       
      out.writeObject(info.getFamilyName());
      out.writeObject(info.getTargets());
   }
   
   /**
   *  Un-externalize this instance.
   *
   *  We check timestamps of the interfaces to see if the instance is in the original VM of creation
   */
   public void readExternal(final java.io.ObjectInput in)
      throws IOException, ClassNotFoundException
   {
      String proxyFamilyName = (String)in.readObject();
      ArrayList targets = (ArrayList)in.readObject();
      // keep a reference on our family object
      //
      this.info = ClusteringTargetsRepository.initTarget(proxyFamilyName, targets);
   }
   
}
