/***************************************
 *                                     *
 *  JBoss: The OpenSource J2EE WebOS   *
 *                                     *
 *  Distributable under LGPL license.  *
 *  See terms of license at gnu.org.   *
 *                                     *
 ***************************************/

package org.jboss.aspects.security;

import gnu.regexp.REException;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2.2.1 $
 */
public class SecurityClassMetaDataBinding extends org.jboss.aop.metadata.ClassMetaDataBinding
{
   protected ArrayList securityRoles = new ArrayList();
   protected ArrayList methodPermissions = new ArrayList();
   protected ArrayList methodExcludeList = new ArrayList();
   protected ArrayList constructorPermissions = new ArrayList();
   protected ArrayList constructorExcludeList = new ArrayList();
   protected HashMap fieldPermissions = new HashMap();
   protected ArrayList fieldExcludeList = new ArrayList();
   protected String runAs;
   protected String securityDomain;

   public SecurityClassMetaDataBinding(org.jboss.aop.metadata.ClassMetaDataLoader loader, String name, String group, String expr) throws REException
   {
      super(loader, name, group, expr);
   }

   public String getSecurityDomain()
   {
      return securityDomain;
   }

   public void setSecurityDomain(String domain)
   {
      securityDomain = domain;
   }

   public ArrayList getSecurityRoles()
   {
      return securityRoles;
   }

   public void setSecurityRoles(ArrayList roles)
   {
      securityRoles = roles;
   }

   public ArrayList getMethodPermissions()
   {
      return methodPermissions;
   }

   public void setMethodPermissions(ArrayList permissions)
   {
      methodPermissions = permissions;
   }

   public ArrayList getMethodExcludeList()
   {
      return methodExcludeList;
   }

   public void setMethodExcludeList(ArrayList list)
   {
      methodExcludeList = list;
   }

   public HashMap getFieldPermissions()
   {
      return fieldPermissions;
   }

   public void setFieldPermissions(HashMap permissions)
   {
      fieldPermissions = permissions;
   }

   public ArrayList getFieldExcludeList()
   {
      return fieldExcludeList;
   }

   public void setFieldExcludeList(ArrayList list)
   {
      fieldExcludeList = list;
   }

   public ArrayList getConstructorPermissions()
   {
      return constructorPermissions;
   }

   public void setConstructorPermissions(ArrayList permissions)
   {
      constructorPermissions = permissions;
   }

   public ArrayList getConstructorExcludeList()
   {
      return constructorExcludeList;
   }

   public void setConstructorExcludeList(ArrayList list)
   {
      constructorExcludeList = list;
   }

   public String getRunAs()
   {
      return runAs;
   }

   public void setRunAs(String as)
   {
      runAs = as;
   }

}
