/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aspects.tx;

import org.jboss.aop.joinpoint.FieldReadInvocation;
import org.jboss.aop.joinpoint.FieldWriteInvocation;
import org.jboss.tm.TxManager;

/**
 * This aspect should be scoped PER_JOINPOINT
 * It allows a field to be like a ThreadLocal
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 */
public class TransactionInjector
{
   public Object access(FieldReadInvocation invocation) throws Throwable
   {
      return TxManager.getInstance().getTransaction();
   }

   public Object access(FieldWriteInvocation invocation) throws Throwable
   {
      throw new RuntimeException("It is illegal to set an injected Transaction field.");
   }
}
