/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aspects.versioned;
import org.jboss.util.id.GUID;

import java.util.HashSet;

public class DistributedSetUpdate implements java.io.Serializable, DistributedUpdate
{
   public GUID guid;
   public long versionId;
   /**
    * This is a list of VersionReference's or serializable objects
    */
   public HashSet setUpdates;

   public DistributedSetUpdate() {}

   public DistributedSetUpdate(GUID guid, HashSet updates, long versionId)
   {
      this.guid = guid;
      this.setUpdates = updates;
      this.versionId = versionId;
   }
   
   public GUID getGUID() { return guid; }

}
