/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aspects.versioned;
import org.jboss.aop.InstanceAdvised;
import org.jboss.util.id.GUID;

import javax.transaction.Transaction;

public interface DistributedState
{
   public GUID getGUID();
   public DistributedUpdate createTxUpdate(Transaction tx);
   public InstanceAdvised buildObject(SynchronizationManager manager, DistributedVersionManager versionManager) throws Exception;
   public void mergeState(DistributedUpdate update) throws Exception;
   public void mergeState(Transaction tx) throws Exception;
   public void checkOptimisticLock(Transaction tx);
   public InstanceAdvised getObject();
   public void acquireWriteLock();
   public void acquireReadLock();
   public void releaseReadLock();
   public void releaseWriteLock();
}
