/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.aspects.versioned;

import org.jboss.util.id.GUID;

import javax.transaction.Transaction;
import java.util.List;
/**
 *
 *  @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 *  @version $Revision: 1.1 $
 */
public interface SynchronizationManager
{
   public Object getObject(GUID guid);
   public DistributedState getState(GUID guid);
   public void putObject(GUID guid, Object obj);
   public void putState(GUID guid, Object obj);
   public void noTxUpdate(DistributedUpdate update) throws Exception;
   public void registerUpdate(Transaction tx, DistributedState state) throws Exception;
   public void createObjects(List newObjects) throws Exception;
   
}
