/*
 * Asynchronous Engine .
 *
 * Copyright (C) 2004 Claude Hussenet
 * Contact : chussenet@yahoo.com
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package test.asynchronous;

/**
 *
 * @version <tt>$Revision: 1.3 $</tt>
 * @author  <a href="mailto:chussenet@yahoo.com">{Claude Hussenet Independent Consultant}</a>.
 */


public class BusinessModel {
	protected long sleepTime = 100;
	public boolean bCleanupCalled = false;
	public BusinessModel() {}
	public BusinessModel(long sleepTime) {
		this.sleepTime = sleepTime;
	}
	public static void sleep(long sleep) {
		try {
			Thread.sleep(sleep);
		} catch (Exception e) {}
	}
	/**
	 * @@org.jboss.aspects.asynchronous.aspects.jboss.Asynchronous
 	 */
	public void processBusinessModel() {
		sleep(sleepTime);
	}
	/**
	 * @@org.jboss.aspects.asynchronous.aspects.jboss.Asynchronous
	 */
	private void processBusinessModel3() {
		sleep(sleepTime);
	}

	/**
	 * @@org.jboss.aspects.asynchronous.aspects.jboss.Asynchronous
	 */
	public void callPrivateMethod() {
		processBusinessModel3();
	}

 	/**
 	 * @@org.jboss.aspects.asynchronous.aspects.jboss.Asynchronous
	 */
	public long processBusinessModel2(long aSleepTime) {
		if (aSleepTime < 0) {
			int a = 0 / 0;
		}
		sleep(aSleepTime);
		return aSleepTime;
	}
 	/**
 	 * @@org.jboss.aspects.asynchronous.aspects.jboss.Asynchronous
	 */
	static public long processBusinessModel4(
		long aSleepTime,
		Parameter parameter) {
		sleep(aSleepTime);
		return aSleepTime;
	}
}
