/*
 * Read Write Lock Pattern .
 *
 * Copyright (C) 2004 Claude Hussenet
 * Contact : chussenet@yahoo.com
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package test.patterns.readwritelock;
/**
 * @version <tt>$Revision: 1.2 $</tt>
 * @author  <a href="mailto:chussenet@yahoo.com">{Claude Hussenet Independent Consultant}</a>.
 */
public class Account
{

  private float balance;

   public Account(float balance)
   {
	this.balance=balance;
   }

   public void debit(float amount)
   {
	   float currentBalance = balance;
	   process(amount);
       this.balance = currentBalance-amount;
   }

   public void credit(float amount)
   {
	   float currentBalance = balance;
	   process(amount);
       this.balance = currentBalance+amount;
   }

   public String toString()
   {
	 return new StringBuffer("Balance: $").append(this.balance).toString();
   }
   public float getBalance()
   {
	return balance;
   }

   public void process(float ll)
   {
	  try {

		  Thread.currentThread().sleep((long)ll);
	  }
	  catch (Exception e)
	  {
		  System.out.println(e);
	  }
   }
}


