/**
 * JBoss, the OpenSource J2EE webOS
 * <p/>
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package javax.management.j2ee.statistics;

// $Id: JTAStats.java,v 1.6 2004/02/17 14:48:30 tdiesler Exp $


/**
 * Specifies the statistics provided by a JTA resource.
 * 
 * @author thomas.diesler@jboss.org
 */
public interface JTAStats extends Stats
{
   /**
    * Number of active transactions.
    */
   public CountStatistic getActiveCount();

   /**
    * Number of committed transactions.
    */
   public CountStatistic getCommittedCount();

   /**
    * Number of rolled-back transactions.
    */
   public CountStatistic getRolledbackCount();
}

