package org.jboss.management.j2ee.statistics;

import org.jboss.management.j2ee.StatisticsConstants;

import javax.management.j2ee.statistics.ServletStats;
import javax.management.j2ee.statistics.TimeStatistic;

/**
 * The implementation of the JSR77 ServletStats model
 *
 * @author Scott.Stark@jboss.org
 * @version $Revision: 1.5 $
 */
public class ServletStatsImpl extends StatsBase
        implements ServletStats
{
   public ServletStatsImpl()
   {
      this(new TimeStatisticImpl("ServiceTime", StatisticsConstants.MILLISECOND,
              "The execution time of the servlet"));
   }

   public ServletStatsImpl(TimeStatistic serviceTime)
   {
      addStatistic("ServiceTime", serviceTime);
   }

   public TimeStatistic getServiceTime()
   {
      return (TimeStatistic) getStatistic("ServiceTime");
   }
}
