/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.jbossmq.test;

import junit.framework.Test;
import junit.framework.TestCase;
import javax.jms.*;
import org.jboss.mq.SpyConnectionFactory;
import org.jboss.test.JBossTestCase;
import java.util.Properties;
import org.jboss.mq.SpyXAConnectionFactory;
import javax.naming.*;
import org.jboss.test.util.AppCallbackHandler;
import javax.security.auth.login.LoginContext;

/** 
 * Test all the verious ways that a connection can be 
 * established with JBossMQ
 *
 * @author hiram.chirino@jboss.org
 * @version $Revision: 1.2 $
 */
public class RMIConnectionUnitTestCase extends JBossTestCase {

   public RMIConnectionUnitTestCase(String name) {
      super(name);
   }

   protected void setUp() throws Exception {
   }

   public void testMultipleRMIConnectViaJNDI() throws Exception {
      
      getLog().debug("Starting testMultipleRMIConnectViaJNDI");

      InitialContext ctx = new InitialContext();

      QueueConnectionFactory cf = (QueueConnectionFactory) ctx.lookup("RMIConnectionFactory");

		QueueConnection connections[] = new QueueConnection[10];
		
      getLog().debug("Creating "+connections.length+" connections.");
     for( int i=0; i < connections.length; i++ ) {
	     connections[i] = cf.createQueueConnection();
      }   

      getLog().debug("Closing the connections.");
     for( int i=0; i < connections.length; i++ ) {
	     connections[i].close();
      }   
      
      getLog().debug("Finished testMultipleRMIConnectViaJNDI");
   }

   public void testRMIConnectViaJNDI() throws Exception {
      InitialContext ctx = new InitialContext();

      QueueConnectionFactory cf = (QueueConnectionFactory) ctx.lookup("RMIConnectionFactory");
      QueueConnection c = cf.createQueueConnection();
      c.close();

      XAQueueConnectionFactory xacf = (XAQueueConnectionFactory) ctx.lookup("RMIXAConnectionFactory");
      XAQueueConnection xac = xacf.createXAQueueConnection();
      xac.close();
   }

   public static void main(java.lang.String[] args) {
      junit.textui.TestRunner.run(RMIConnectionUnitTestCase.class);
   }
}
