/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.webservice.message;

// $Id: MessageEndpoint.java,v 1.1.2.2 2004/12/08 15:43:45 tdiesler Exp $

import org.w3c.dom.Element;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * @author Thomas.Diesler@jboss.org
 * @since 26-Nov-2004
 */
public interface MessageEndpoint extends Remote
{
   static final String NAMESPACE_URI = "http://ws.sample";
   static final String PREFIX = "ns1";

   String request =
           "<ns1:Order xmlns:ns1='http://ws.sample'>" +
           "  <Customer>Kermit</Customer>" +
           "  <Item>Ferrari</Item>" +
           "</ns1:Order>";

   String response =
           "<ns1:Response xmlns:ns1='http://ws.sample'>" +
           "  <POID>12345</POID>" +
           "  <Status>ok</Status>" +
           "</ns1:Response>";

   public Element processElement(Element msg) throws RemoteException;
}
