/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package com.underworld.crimeportal;

// $Id: ClientSideApplTestCase.java,v 1.1.4.1 2004/11/13 18:49:01 tdiesler Exp $

import junit.framework.TestCase;

import javax.naming.InitialContext;

/**
 * Test access to the webservice via an EJB client
 *
 * @author Thomas.Diesler@jboss.org
 * @since 26-Apr-2004
 */
public class ClientSideApplTestCase extends TestCase
{

   public ClientSideApplTestCase(String name)
   {
      super(name);
   }

   /** Test access to the EJB webservice via an app client */
   public void testApplClientAccessEJB() throws Exception
   {
      InitialContext iniCtx = new InitialContext();
      javax.xml.rpc.Service service = (javax.xml.rpc.Service)iniCtx.lookup("java:comp/env/service/OrganizationServiceEJB");
      OrganizationEndpoint endpoint = (OrganizationEndpoint)service.getPort(OrganizationEndpoint.class);
      String info = endpoint.getContactInfo("mafia");
      assertEquals("The 'mafia' boss is currently out of office, please call again.", info);
   }

   /** Test access to the JSE webservice via an app client */
   public void testApplClientAccessJSE() throws Exception
   {
      InitialContext iniCtx = new InitialContext();
      OrganizationEndpointService service = (OrganizationEndpointService)iniCtx.lookup("java:comp/env/service/OrganizationServiceJSE");
      OrganizationEndpoint endpoint = (OrganizationEndpoint)service.getOrganizationPort();
      String info = endpoint.getContactInfo("mafia");
      assertEquals("The 'mafia' boss is currently out of office, please call again.", info);
   }
}
