/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package com.underworld.crimeportal;

// $Id: ClientSideServletTestCase.java,v 1.1 2004/08/03 15:19:54 tdiesler Exp $

import junit.framework.TestCase;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;

/**
 * Test access to the webservice via an servlet client
 *
 * @author Thomas.Diesler@jboss.org
 * @since 26-Apr-2004
 */
public class ClientSideServletTestCase extends TestCase
{

   public ClientSideServletTestCase(String name)
   {
      super(name);
   }

   /** Test access to the webservice via an EJB client */
   public void testServletClientAccessEJB() throws Exception
   {
      URL url = new URL("http://localhost:8080/samples-client-web?organization=mafia&endpoint=EJB&method=info");
      BufferedReader br = new BufferedReader(new InputStreamReader(url.openStream()));
      String info = br.readLine();
      assertEquals("The 'mafia' boss is currently out of office, please call again.", info);
   }

   /** Test access to the webservice via an EJB client */
   public void testServletClientAccessJSESimple() throws Exception
   {
      URL url = new URL("http://localhost:8080/samples-client-web?organization=mafia&endpoint=JSE&method=info");
      BufferedReader br = new BufferedReader(new InputStreamReader(url.openStream()));
      String info = br.readLine();
      assertEquals("The 'mafia' boss is currently out of office, please call again.", info);
   }
}
