/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.webservice.complexbean;

// $Id: CustomerOrder.java,v 1.1 2004/08/10 10:14:31 tdiesler Exp $

import java.util.Arrays;

/**
 * An example bean that contains an array of other beans
 *
 * @author Thomas.Diesler@jboss.org
 * @since 10-Aug-2004
 */
public class CustomerOrder
{
   private String orderID;
   private String customerID;
   private CustomerOrderPosition[] positions;

   public String getCustomerID()
   {
      return customerID;
   }

   public void setCustomerID(String customerID)
   {
      this.customerID = customerID;
   }

   public String getOrderID()
   {
      return orderID;
   }

   public void setOrderID(String orderID)
   {
      this.orderID = orderID;
   }

   public CustomerOrderPosition[] getPositions()
   {
      return positions;
   }

   public void setPositions(CustomerOrderPosition[] positions)
   {
      this.positions = positions;
   }

   public int hashCode()
   {
      return toString().hashCode();
   }

   public boolean equals(Object obj)
   {
      return toString().equals("" + obj);
   }

   public String toString()
   {
      String pos = (positions != null ? Arrays.asList(positions).toString() : "[]");
      return "[cuid=" + customerID + ",oid=" + orderID + ",pos=" + pos + "]";
   }

}
