/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.webservice.complexbean.ejb;

// $Id: CustomerOrderBean.java,v 1.1.2.1 2004/09/20 11:10:42 tdiesler Exp $

import org.jboss.logging.Logger;
import org.jboss.webservice.complexbean.CustomerOrder;
import org.jboss.webservice.complexbean.CustomerArray;
import org.jboss.webservice.complexbean.Customer;

import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.RemoteException;

/**
 * An example of a SLSB
 *
 * @author Thomas.Diesler@jboss.org
 * @ejb.bean name="CustomerOrderService"
 * type="Stateless"
 * @since 10-Aug-2004
 */
public class CustomerOrderBean implements SessionBean
{
   // provide logging
   private static final Logger log = Logger.getLogger(CustomerOrderBean.class);

   private SessionContext ctx;

   /**
    * @ejb.interface-method
    */
   public CustomerOrder echoCustomerOrder(CustomerOrder order)
   {
      log.info("echoCustomerOrder: " + order);
      return order;
   }

   public CustomerArray echoCustomerArr(CustomerArray customerArray)
   {
      log.info("echoCustomerArr: " + customerArray);
      return customerArray;
   }

   // SLSB Lifecycle ***************************************************************************************************

   public void ejbCreate()
   {
      log.debug("ejbCreate");
   }

   public void setSessionContext(SessionContext ctx) throws EJBException, RemoteException
   {
      log.debug("setSessionContext");
      this.ctx = ctx;
   }

   public void ejbRemove() throws EJBException, RemoteException
   {
      log.debug("ejbRemove");
   }

   public void ejbActivate() throws EJBException, RemoteException
   {
      log.debug("ejbActivate");
   }

   public void ejbPassivate() throws EJBException, RemoteException
   {
      log.debug("ejbPassivate");
   }
}
