/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package com.underworld.crimeportal;

// $Id: ServerSideEJBTestCase.java,v 1.1.4.2 2004/11/13 23:02:03 tdiesler Exp $

import junit.framework.TestCase;

import javax.xml.namespace.QName;
import javax.xml.rpc.Service;
import javax.xml.rpc.ServiceFactory;
import java.net.URL;


/**
 * A web service client that connects to a SLSB endpoint using
 * the dynamic invokation interface (DII).
 *
 * @author Thomas.Diesler@jboss.org
 * @since 26-Apr-2004
 */
public class ServerSideEJBTestCase extends TestCase
{

   private Service service;

   public ServerSideEJBTestCase(String name)
   {
      super(name);
   }

   protected void setUp() throws Exception
   {
      URL url = new URL("http://localhost:8080/samples-server-ejb/Organization?wsdl");
      QName qname = new QName("http://com.underworld.crimeportal", "OrganizationService");
      ServiceFactory factory = ServiceFactory.newInstance();
      service = factory.createService(url, qname);
   }

   public void testWebServiceAccess() throws Exception
   {
      OrganizationEndpoint endpoint = (OrganizationEndpoint)service.getPort(OrganizationEndpoint.class);
      String info = endpoint.getContactInfo("mafia");
      assertEquals("The 'mafia' boss is currently out of office, please call again.", info);
   }
}
