/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package com.underworld.crimeportal.ejb;

// $Id: OrganizationSLSB.java,v 1.1.2.1 2004/10/24 15:34:59 tdiesler Exp $

import org.jboss.logging.Logger;

import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.RemoteException;

/**
 * An example of a SLSB
 *
 * @author Thomas.Diesler@jboss.org
 * @since 26-Apr-2004
 */
public class OrganizationSLSB implements SessionBean
{
   // provide logging
   private static final Logger log = Logger.getLogger(OrganizationSLSB.class);

   private SessionContext ctx;

   /** Get the contact info */
   public String getContactInfo(String organization) throws RemoteException
   {
      log.info("getContactInfo: " + organization);
      return "The '" + organization + "' boss is currently out of office, please call again.";
   }

   // SLSB Lifecycle ***************************************************************************************************

   public void ejbCreate()
   {
      log.debug("ejbCreate");
   }

   public void setSessionContext(SessionContext ctx) throws EJBException, RemoteException
   {
      log.debug("setSessionContext");
      this.ctx = ctx;
   }

   public void ejbRemove() throws EJBException, RemoteException
   {
      log.debug("ejbRemove");
   }

   public void ejbActivate() throws EJBException, RemoteException
   {
      log.debug("ejbActivate");
   }

   public void ejbPassivate() throws EJBException, RemoteException
   {
      log.debug("ejbPassivate");
   }
}
