/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package com.underworld.crimeportal;

// $Id: ServerSideWEBTestCase.java,v 1.1.4.1 2004/10/24 15:35:18 tdiesler Exp $

import junit.framework.TestCase;

import javax.xml.namespace.QName;
import javax.xml.rpc.Service;
import javax.xml.rpc.ServiceFactory;
import java.net.URL;

/**
 * An example that accesses a java service endpoint
 *
 * @author Thomas.Diesler@jboss.org
 * @since 26-Apr-2004
 */
public class ServerSideWEBTestCase extends TestCase
{
   public ServerSideWEBTestCase(String name)
   {
      super(name);
   }

   protected void setUp() throws Exception
   {
   }

   public void testServletContextExactAccess() throws Exception
   {
      URL url = new URL("http://localhost:8080/samples-server-jse/exactpath/jse?wsdl");
      QName qname = new QName("http://com.underworld.crimeportal", "OrganizationService");

      ServiceFactory factory = ServiceFactory.newInstance();
      Service service = factory.createService(url, qname);
      OrganizationEndpoint endpoint = (OrganizationEndpoint)service.getPort(OrganizationEndpoint.class);

      String info = endpoint.getContactInfo("mafia");
      assertEquals("The 'mafia' boss is currently out of office, please call again.", info);
   }

   public void testServletContextWildAccess() throws Exception
   {
      URL url = new URL("http://localhost:8080/samples-server-jse/wildpath/somemore/jse?wsdl");
      QName qname = new QName("http://com.underworld.crimeportal", "OrganizationService");

      ServiceFactory factory = ServiceFactory.newInstance();
      Service service = factory.createService(url, qname);
      OrganizationEndpoint endpoint = (OrganizationEndpoint)service.getPort(OrganizationEndpoint.class);

      String info = endpoint.getContactInfo("mafia");
      assertEquals("The 'mafia' boss is currently out of office, please call again.", info);
   }
}
