/**
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.webservice.encoding.ser;

// $Id: MetaDataBeanDeserializerFactory.java,v 1.1.4.2 2004/11/17 10:51:35 tdiesler Exp $

import org.apache.axis.encoding.Deserializer;
import org.apache.axis.encoding.ser.BaseDeserializerFactory;
import org.jboss.webservice.deployment.BeanXMLMetaData;

import javax.xml.namespace.QName;

/** A factory for the MetaDataBeanDeserializer
 *
 * @author thomas.diesler@jboss.org
 */
public class MetaDataBeanDeserializerFactory extends BaseDeserializerFactory
{
   private BeanXMLMetaData metaData;

   public MetaDataBeanDeserializerFactory(Class javaType, QName xmlType)
   {
      super(MetaDataBeanDeserializer.class, xmlType, javaType);
   }

   public void setMetaData(BeanXMLMetaData metaData)
   {
      this.metaData = metaData;
   }

   protected Deserializer getSpecialized(String mechanismType)
   {
      return newMetaDataBeanDeserializer();
   }

   protected Deserializer getGeneralPurpose(String mechanismType)
   {
      return newMetaDataBeanDeserializer();
   }

   private MetaDataBeanDeserializer newMetaDataBeanDeserializer()
   {
      return new MetaDataBeanDeserializer(javaType, xmlType, metaData);
   }
}
