/**
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.webservice.encoding.ser;

// $Id: MetaDataBeanSerializerFactory.java,v 1.2.4.2 2004/11/17 10:51:35 tdiesler Exp $

import org.apache.axis.encoding.Serializer;
import org.apache.axis.encoding.ser.BaseSerializerFactory;
import org.jboss.webservice.deployment.BeanXMLMetaData;

import javax.xml.namespace.QName;

/** A factory for the MetaDataBeanSerializer
 *
 * @author thomas.diesler@jboss.org
 */
public class MetaDataBeanSerializerFactory extends BaseSerializerFactory
{
   private BeanXMLMetaData metaData;

   public MetaDataBeanSerializerFactory(Class javaType, QName xmlType)
   {
      super(MetaDataBeanSerializer.class, xmlType, javaType);
   }

   public void setMetaData(BeanXMLMetaData metaData)
   {
      this.metaData = metaData;
   }

   protected Serializer getSpecialized(String mechanismType)
   {
      return new MetaDataBeanSerializer(javaType, xmlType, metaData);
   }

   protected Serializer getGeneralPurpose(String mechanismType)
   {
      return new MetaDataBeanSerializer(javaType, xmlType, metaData);
   }
}
