/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.webservice.server;

// $Id: JBossAdminServlet.java,v 1.2 2004/07/20 13:48:57 tdiesler Exp $

import org.apache.axis.AxisFault;
import org.apache.axis.server.AxisServer;
import org.apache.axis.transport.http.AdminServlet;
import org.jboss.logging.Logger;
import org.jboss.mx.util.MBeanServerLocator;
import org.jboss.webservice.AxisServiceMBean;

import javax.management.MBeanServer;

/**
 * An JBossAdminServlet that gets the AxisServer config via JMX from the AxisService
 *
 * @author Thomas.Diesler@jboss.org
 * @since 15-April-2004
 */
public class JBossAdminServlet extends AdminServlet
{
   // provide logging
   private static final Logger log = Logger.getLogger(JBossAdminServlet.class);

   /**
    * Get an AxisServer with the EngineConfiguration from the JMX AxisService
    */
   public AxisServer getEngine() throws AxisFault
   {
      try
      {
         MBeanServer server = MBeanServerLocator.locateJBoss();
         axisServer = (AxisServer)server.getAttribute(AxisServiceMBean.OBJECT_NAME, "AxisServer");

      }
      catch (Exception e)
      {
         log.warn("Cannot access AxisService, using default server config");
         axisServer = super.getEngine();
      }

      return axisServer;
   }
}
